Signed-off-by: David Wu <davidwu@arcturusnetworks.com>
diff -urNa u-boot-2009.11/drivers/i2c/fsl_i2c.c u-boot-2009.11-patched/drivers/i2c/fsl_i2c.c
--- u-boot-2009.11/drivers/i2c/fsl_i2c.c	2009-12-15 17:20:54.000000000 -0500
+++ u-boot-2009.11-patched/drivers/i2c/fsl_i2c.c	2009-12-31 14:16:55.000000000 -0500
@@ -251,12 +251,25 @@
 #endif
 }
 
+static __inline__ int i2c_set_idle(void)
+{
+	writeb(0, &i2c_dev[i2c_bus_num]->cr);
+	writeb(I2C_CR_MEN | I2C_CR_MSTA, &i2c_dev[i2c_bus_num]->cr);
+	readb(&i2c_dev[i2c_bus_num]->dr);
+	writeb(0, &i2c_dev[i2c_bus_num]->sr);
+	writeb(0, &i2c_dev[i2c_bus_num]->cr);
+	writeb(I2C_CR_MEN, &i2c_dev[i2c_bus_num]->cr);
+}
+
 static int
 i2c_wait4bus(void)
 {
 	unsigned long long timeval = get_ticks();
 	const unsigned long long timeout = usec2ticks(CONFIG_I2C_MBB_TIMEOUT);
 
+	if (readb(&i2c_dev[i2c_bus_num]->sr) & I2C_SR_MBB)
+		i2c_set_idle();
+
 	while (readb(&i2c_dev[i2c_bus_num]->sr) & I2C_SR_MBB) {
 		if ((get_ticks() - timeval) > timeout)
 			return -1;
